Package org.apache.sis.metadata.iso.distribution

## Class DefaultMedium

- Object
- - AbstractMetadata
  - - ModifiableMetadata
    - - ISOMetadata
      - - DefaultMedium

- All Implemented Interfaces:
    `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `Medium`

      public class DefaultMedium
      extends ISOMetadata
      implements Medium

  Information about the media on which the resource can be distributed. The following property is mandatory or conditional (i.e. mandatory under some circumstances) in a well-formed metadata according ISO 19115:
  `MD_Medium` `└─densityUnits……` Units of measure for the recording density.

  Limitations:

  - Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
  - Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.
  Since:
    0.3
  See Also:
    Serialized Form

  Defined in the `sis-metadata` module

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class ModifiableMetadata

      `ModifiableMetadata​.State`

  - ### Field Summary

    - ### Fields inherited from class ISOMetadata

      `identifiers`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DefaultMedium()` | Constructs an initially empty medium.
    `DefaultMedium​(Medium object)` | Constructs a new instance initialized with the values from the specified metadata object.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static DefaultMedium` | `castOrCopy​(Medium object)` | Returns a SIS metadata implementation with the values of the given arbitrary implementation.
    `Collection<Double>` | `getDensities()` | Deprecated. As of ISO 19115:2014, replaced by `getDensity()`.
    `Double` | `getDensity()` | Returns the density at which the data is recorded.
    `Unit<?>` | `getDensityUnits()` | Returns the units of measure for the recording density.
    `Identifier` | `getIdentifier()` | Returns a unique identifier for an instance of the medium.
    `Collection<MediumFormat>` | `getMediumFormats()` | Returns the method used to write to the medium.
    `InternationalString` | `getMediumNote()` | Returns a description of other limitations or requirements for using the medium.
    `MediumName` | `getName()` | Returns the name of the medium on which the resource can be received.
    `Integer` | `getVolumes()` | Returns the number of items in the media identified.
    `void` | `setDensities​(Collection<? extends Double> newValues)` | Deprecated. As of ISO 19115:2014, replaced by `setDensity(Double)`.
    `void` | `setDensity​(Double newValue)` | Sets density at which the data is recorded.
    `void` | `setDensityUnits​(Unit<?> newValue)` | Sets the units of measure for the recording density.
    `void` | `setIdentifier​(Identifier newValue)` | Sets a unique identifier for an instance of the medium.
    `void` | `setMediumFormats​(Collection<? extends MediumFormat> newValues)` | Sets the method used to write to the medium.
    `void` | `setMediumNote​(InternationalString newValue)` | Sets a description of other limitations or requirements for using the medium.
    `void` | `setName​(MediumName newValue)` | Sets the name of the medium on which the resource can be received.
    `void` | `setVolumes​(Integer newValue)` | Sets the number of items in the media identified.

    - ### Methods inherited from class ISOMetadata

      `getIdentifierMap, getIdentifiers, getStandard, transitionTo`

    - ### Methods inherited from class ModifiableMetadata

      `checkWritePermission, checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, freeze, isModifiable, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, unmodifiable, writeCollection, writeList, writeMap, writeSet`

    - ### Methods inherited from class AbstractMetadata

      `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

    - ### Methods inherited from class Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultMedium

          public DefaultMedium()

      Constructs an initially empty medium.

    - #### DefaultMedium

          public DefaultMedium​(Medium object)

      Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
      Note on properties validation: This constructor does not verify the property values of the given metadata (e.g. whether it contains unexpected negative values). This is because invalid metadata exist in practice, and verifying their validity in this copy constructor is often too late. Note that this is not the only hole, as invalid metadata instances can also be obtained by unmarshalling an invalid XML document.
      Parameters:
        `object` - the metadata to copy values from, or `null` if none.
      See Also:
        `castOrCopy(Medium)`

  - ### Method Detail

    - #### castOrCopy

          public static DefaultMedium castOrCopy​(Medium object)

      Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
      - If the given object is `null`, then this method returns `null`.
      - Otherwise if the given object is already an instance of `DefaultMedium`, then it is returned unchanged.
      - Otherwise a new `DefaultMedium` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the object to get as a SIS implementation, or `null` if none.
      Returns:
        a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

    - #### getName

          public MediumName getName()

      Returns the name of the medium on which the resource can be received.
      Upcoming API change
      `MediumName` may be replaced by `Citation` in GeoAPI 4.0.
      Specified by:
        `getName` in interface `Medium`
      Returns:
        name of the medium, or `null`.
      See Also:
        SIS-389

    - #### setName

          public void setName​(MediumName newValue)

      Sets the name of the medium on which the resource can be received.
      Upcoming API change
      `MediumName` may be replaced by `Citation` in GeoAPI 4.0.
      Parameters:
        `newValue` - the new name.

    - #### getDensity

          @ValueRange(minimum=0.0,
                      isMinIncluded=false)
          @UML(identifier="density",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public Double getDensity()

      Returns the density at which the data is recorded. The number shall be greater than zero.
      Returns:
        density at which the data is recorded, or `null`.
      Since:
        0.5

    - #### setDensity

          public void setDensity​(Double newValue)

      Sets density at which the data is recorded. The number shall be greater than zero.
      Parameters:
        `newValue` - the new density.
      Throws:
        `IllegalArgumentException` - if the given value is NaN, zero or negative.
      Since:
        0.5

    - #### getDensities

          @Deprecated
          public Collection<Double> getDensities()

      Deprecated.
      As of ISO 19115:2014, replaced by `getDensity()`.
      Specified by:
        `getDensities` in interface `Medium`
      Returns:
        density at which the data is recorded, or `null`.

    - #### setDensities

          @Deprecated
          public void setDensities​(Collection<? extends Double> newValues)

      Deprecated.
      As of ISO 19115:2014, replaced by `setDensity(Double)`.
      Parameters:
        `newValues` - the new densities.

    - #### getDensityUnits

          public Unit<?> getDensityUnits()

      Returns the units of measure for the recording density.
      Specified by:
        `getDensityUnits` in interface `Medium`
      Returns:
        units of measure for the recording density, or `null`.

    - #### setDensityUnits

          public void setDensityUnits​(Unit<?> newValue)

      Sets the units of measure for the recording density.
      Parameters:
        `newValue` - the new density units.

    - #### getVolumes

          @ValueRange(minimum=0.0)
          public Integer getVolumes()

      Returns the number of items in the media identified.
      Specified by:
        `getVolumes` in interface `Medium`
      Returns:
        number of items in the media identified, or `null`.

    - #### setVolumes

          public void setVolumes​(Integer newValue)

      Sets the number of items in the media identified.
      Parameters:
        `newValue` - the new volumes, or `null`.
      Throws:
        `IllegalArgumentException` - if the given value is negative.

    - #### getMediumFormats

          public Collection<MediumFormat> getMediumFormats()

      Returns the method used to write to the medium.
      Specified by:
        `getMediumFormats` in interface `Medium`
      Returns:
        method used to write to the medium, or `null`.

    - #### setMediumFormats

          public void setMediumFormats​(Collection<? extends MediumFormat> newValues)

      Sets the method used to write to the medium.
      Parameters:
        `newValues` - the new medium formats.

    - #### getMediumNote

          public InternationalString getMediumNote()

      Returns a description of other limitations or requirements for using the medium.
      Specified by:
        `getMediumNote` in interface `Medium`
      Returns:
        description of other limitations for using the medium, or `null`.

    - #### setMediumNote

          public void setMediumNote​(InternationalString newValue)

      Sets a description of other limitations or requirements for using the medium.
      Parameters:
        `newValue` - the new medium note.

    - #### getIdentifier

          @UML(identifier="identifier",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public Identifier getIdentifier()

      Returns a unique identifier for an instance of the medium.
      Overrides:
        `getIdentifier` in class `ISOMetadata`
      Returns:
        unique identifier, or `null` if none.
      Since:
        0.5

    - #### setIdentifier

          public void setIdentifier​(Identifier newValue)

      Sets a unique identifier for an instance of the medium.
      Overrides:
        `setIdentifier` in class `ISOMetadata`
      Parameters:
        `newValue` - the new identifier.
      Since:
        0.5